/*
 * @COPYRIGHT@
 * 
 * x-kernel v3.3
 * 
 * Copyright (c) 1993,1991,1990,1996  Arizona Board of Regents
 * 
 * @COPYRIGHT@
 *
 * $RCSfile: scout_util.c,v $
 *
 * HISTORY
 * $Log: scout_util.c,v $
 * Revision 1.4  1996/01/30  22:49:51  slm
 * Updated copyright and version.
 *
 * Revision 1.3.1.1  1994/12/02  23:53:16  hkaram
 * New branch
 *
 * Revision 1.3  1994/06/11  00:02:35  menze
 * Added copyright notice
 *
 * Revision 1.2  1994/05/14  23:57:51  davidm
 * Fixed RCS header.
 */
#include <stdarg.h>
#include "scout.h"
#include "scout_config.h"
#include "kgdb.h"


void
scout_panic(const char *last_word)
{
    int ch;

    while ((ch = *last_word++) != '\0') {
	putchar(ch);
    } /* while */
    putchar('\n');

#ifdef SCOUT_KGDB
    last_word = "kgdb: waiting for remote gdb to connect...";
    while ((ch = *last_word++) != '\0') {
	putchar(ch);
    } /* while */
    putchar('\n');
#endif /* SCOUT_KGDB */

    kgdb_breakpoint();
    halt();
} /* scout_panic */


void
scout_abort(const char *format, ...)
{
    va_list ap;

    va_start(ap, format);
    vprintf(format, ap);
    va_end(ap);
    halt();
} /* scout_abort */

			/*** end of scout_util.c ***/
