/*
 * @COPYRIGHT@
 * 
 * x-kernel v3.3
 * 
 * Copyright (c) 1993,1991,1990,1996  Arizona Board of Regents
 * 
 * @COPYRIGHT@
 *
 * $RCSfile: alpha_misc.h,v $
 *
 * HISTORY
 * $Log: alpha_misc.h,v $
 * Revision 1.1  1996/01/30  22:55:35  slm
 * Initial revision
 *
 * Revision 1.5  1995/03/08  21:47:37  davidm
 * Added draina().
 *
 * Revision 1.4  1994/11/20  01:32:27  davidm
 * Added imb() and scout_flush_write_to_memory().
 *
 * Revision 1.3  1994/06/11  00:02:51  menze
 * Added copyright notice
 *
 * Revision 1.2  1994/05/15  00:01:45  davidm
 * RCS header added.
 */
#ifndef alpha_misc_h
#define alpha_misc_h

#include "scout.h"
#include "alpha_pal.h"

#define P_TO_K0SEG(pa)	((__typeof(pa))((long)(pa) | 0xfffffc0000000000L))
#define K0SEG_TO_P(va)	((__typeof(va))((long)(va) & 0x000003ffffffffffL))

#define read_itimer() \
	({u_long r; asm volatile("rpcc %0" : "=r" (r)); (u_int)r;})

#define imb()		{asm volatile("call_pal %0" :: "i"(PAL_imb));}
#define draina()	{asm volatile("call_pal %0" :: "i"(PAL_draina));}

#define mtpr_mces(v) \
({ \
    register u_long v0 asm ("0"); \
    register u_long a0 asm ("16"); \
    a0 = (v); \
    asm volatile ("call_pal %1 # %0 %2" : "r="(v0) \
		  : "i"(PAL_mtpr_mces), "r"(a0) \
		  : "memory", "0", "1", "16", "22", "23", "24", "25"); \
    v0; \
})

#define PAL_EntInt	0
#define PAL_EntArith	1
#define PAL_EntMM	2
#define PAL_EntIF	3
#define PAL_EntUna	4
#define PAL_EntSys	5

#define wrent(e,a) \
{ \
    register u_long a0 asm ("16"), a1 asm ("17"); \
    a0 = (a); a1 = (e); \
    asm volatile ("call_pal %0 # %1 %2" :: "i"(PAL_wrent), "r"(a0), "r"(a1) \
		  : "memory", "1", "16", "17", "22", "23", "24", "25"); \
}

#define wrkgp(gp) \
{ \
    register u_long a0 asm ("16"); \
    a0 = (gp); \
    asm volatile ("call_pal %0 # %1" :: "i"(PAL_wrkgp), "r"(a0) \
		  : "memory", "1", "16", "17", "22", "23", "24", "25"); \
}

#define rti	{asm volatile ("call_pal %0" :: "i"(PAL_rti) : "memory");}

#define scout_flush_write_to_memory()	{asm volatile ("mb" ::: "memory");}

/*
 * Saved state as it is passed to kgdb_handle_exception.
 */
typedef struct {
    u_long   v0,  t0,  t1,  t2,  t3,  t4,  t5,  t6;
    u_long   t7,  s0,  s1,  s2,  s3,  s4,  s5,  s6;
    u_long   a3,  a4,  a5,  t8,  t9, t10, t11,  ra;
    u_long  t12,  at,  ps;
    u_int   *pc;
    u_long   gp,  a0,  a1,  a2;
} Alpha_Saved_State;

extern void	flush_icache (void);
extern void	halt (void) NORETURN;

#endif /* alpha_misc_h */
